<?php
class HandleSoapClass{
    /** @var AppController */
    static $controller;

    /** @var string */
    static $wsClassName;
    
    function __call ( $func_name, $args ){
		echo "foo";
		exit(0);
        return self::$controller->requestAction('/'.substr(self::$wsClassName,0,-10).'/'.$func_name.'/soap5/', array('pass'=>$args) );
    }
}	

class CsvproductsController extends AppController
{
	var $paginate = array(
        'limit' => 100,
        'order' => array(
            'Csvproduct.id' => 'asc'
        )
    );
	
	var $uses = array('Csvproduct', "Manufacturer", "Aclusersmanufacturer");



	function test() {
	
		$wsdlfile="http://test.langhofer.net/service.php?class=asdf&wsdl";
		$server = new SoapServer($wsdlfile);
		$server->setClass('HandleSoapClass');
		$server->handle();
		
		
	}


	
   function show() {
		if ($this->requireAccess(true, array("accountmanager", "rep"))) {
		

			$selectedisenabled = $this->smartSession('Global.chk_isEnabled', @$_REQUEST['chk_isEnabled'], "");
			$this->set(compact('selectedisenabled'));
			
			$selectedeol = $this->smartSession('Global.chk_eol_round_id', @$_REQUEST['chk_eol_round_id'], "");
			$this->set(compact('selectedeol'));
			
			
			$whereClause = "";
			
			if($selectedisenabled) {
				$whereClause .= " Csvproduct.isEnabled = 'n' ";
				
			} else {
				$whereClause .= " Csvproduct.isEnabled = 'y' ";
			}
			
			
			if($selectedeol) {
				$whereClause .= " and Round.uts_round_until <".time();
			} else {
				$whereClause .= " and (eol_round_id = 0 or Round.uts_round_until >".time().")";
			}
			
			
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id'], 0);
			$this->set(compact('selectedmanufacturerid'));
			
			if ($selectedmanufacturerid>0) {
				$whereClause .= " and manufacturer_id=" .$selectedmanufacturerid ;
			}
			
			$csvproducts = $this->paginate('Csvproduct', array($whereClause) );
			$this->set(compact('csvproducts'));
			
			$this->set("loggedInRoleID", $this->getLoggedInRoleID());
			$this->set("amRoleID", $this->getRoleIdByKey("accountmanager"));
		}
    }
	
	
	function setisenabled($unsafe_id, $unsafe_isEnabled=false) {
		$isEnabled=(bool)$unsafe_isEnabled;
		$id = (int)$unsafe_id;
		$csvproduct = $this->Csvproduct->find("Csvproduct.id=" . $id);
		
		$csvproduct["Csvproduct"]["isEnabled"] =  ($isEnabled == true) ? "y" : "n";
		$this->Csvproduct->save($csvproduct);
		//print_r($csvproduct);
		$this->redirect("/csvproducts/show");
	}
	
	function setshouldbechecked($unsafe_id, $unsafe_shouldBeChecked=false) {
		$shouldBeChecked=(bool)$unsafe_shouldBeChecked;
		$id = (int)$unsafe_id;
		$csvproduct = $this->Csvproduct->find("Csvproduct.id=" . $id);
		
		$csvproduct["Csvproduct"]["shouldBeChecked"] =  ($unsafe_shouldBeChecked == true) ? "y" : "n";
		$this->Csvproduct->save($csvproduct);
		//print_r($csvproduct);
		$this->redirect("/csvproducts/addorchange/" . $csvproduct["Csvproduct"]["id"]);
	}
	
	function eol($unsafe_csvproduct_id) {
		$csvproduct_id=(int)$unsafe_csvproduct_id;
		
		
		
		
		if ($this->requireAccess(true, array("accountmanager"))) {
			
		
			$csvproduct = $this->Csvproduct->find("Csvproduct.id=".$csvproduct_id);
			$this->set(compact('csvproduct'));
			
			
			if (isset($this->params['data'])) {
				$csvproduct["Csvproduct"]["eol_round_id"] = $this->params['data']["Csvproduct"]["eol_round_id"];
				
				if ($this->Csvproduct->save($csvproduct)) {
					$this->redirect("/csvproducts/addorchange/".$csvproduct_id);
				} else {
					$this->flash("Datenbankfehler, bitte wiederholen Sie Ihre Eingaben", "/csvproducts/addorchange/".$csvproduct_id, 10);
				}			
			}
			
			
			
			$currentround = $this->Round->getCurrentRound();

			// alle runden in der zukunft exklusiver aktueller runde anzeigen
			$this->set('currentroundid', $this->Round->getCurrentRoundID() );
			$rounds = $this->Round->findAll("Round.isEnabled='y' and uts_round_until> ". $currentround["Round"]["uts_round_until"]);
			$this->set('rounds', $rounds);
			
			
			
		}
	}
	function addorchange($unsafe_csvproduct_id=null) {
		$csvproduct_id=(int)$unsafe_csvproduct_id;
		
		if ($this->requireAccess(true, array("accountmanager"))) {
			// account manager
			
			
			
			if (isset($this->params['data'])) {
				// user will daten speichern
				$csvproduct = $this->params['data'];
				//print_r($csvproduct);
				
				// html auf enum('y','n') konvertierung
				$csvproduct["Csvproduct"]["shouldBeChecked"] = isset($csvproduct["Csvproduct"]["shouldBeChecked"]) ? "y" : "n";
				
				// inserted_round_id nur merken wenn das produkt neu angelegt wird und nicht bearbeitet wird
				$csvproduct["Csvproduct"]["inserted_round_id"] = $csvproduct_id>0 ? "" : $this->Round->getCurrentRoundID(); 
				
				// eur betrag zuerst parsen und dann in db schreiben
				$csvproduct["Csvproduct"]["retailPrice"] = $this->parseMoney($csvproduct["Csvproduct"]["retailPrice"]);
				
				
				//exit(0);
				if ($this->Csvproduct->save($csvproduct)) {
					$this->redirect("/csvproducts/show/page:1/sort:productCategory/direction:asc");
				} else {
					$this->flash("Datenbankfehler, bitte wiederholen Sie Ihre Eingaben", "/csvproducts/addorchange", 10);
				}			
				
			} 
			// user will die view (d.h. das formular)
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			
			$csvproduct = $this->Csvproduct->find("Csvproduct.id = " . $csvproduct_id);
	
			//Kategorien werden manuell festgelegt da nicht in der Db vorhanden
			$categories = array('categoryA' => 'A', 'categoryB' => 'B', 'categoryC' => 'C');
		
			$this->set(compact('categories'));
			//print_r($csvproduct);
	//echo "sdf:" .  sizeof($csvproduct);
	//exit(0);
	
			$this->set(compact('csvproduct'));

		}
		
	}


}
?>
